#ifndef _wap_h_
#define _wap_h_
//---------------------------------------------------------------------------
// WAP.h
// Contains all WAP specific stuff
//
// Project: WAPUniverse for PalmOS
// Copyright  1999-2000 Filip Onkelinx
//
// http://www.wapuniverse.com/
// filip@onkelinx.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
//
//
// $Workfile: WAP.h $  
// $Author: wapuniverse $  
// $Date: 2000/11/11 20:51:09 $     
// $Revision: 1.10 $
//
// $Header: /cvsroot/wapuniverse/wapuniverse/src/WAP.h,v 1.10 2000/11/11 20:51:09 wapuniverse Exp $
//
//---------------------------------------------------------------------------
#define WAP_WSP_CL 9200
#define WAP_WSP_CO 9201
#define WAP_WSP_CL_LOCAL 1234
#define WAP_WSP_CO_LOCAL 1235


//#define MAX_URL_LEN 128


#ifdef __palmos__
#include <PalmOS.h>
#include "dbUrl.h"
#include "dbConn.h"
#include <sys_socket.h>
#define Malloc	   MemPtrNew
#define Free(addr) MemPtrFree(addr)
#else
#include "malloc.h"
#include "string.h"
#include <sys/unistd.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#define Malloc     malloc
#define Free(addr) free(addr)
#endif

// WSP

#define WSP_PDU_GET 0x40
#define WSP_PDU_VERSION 0x1A



// function prototypes
int wapGetUrl(dbConnConnection *conn, char *urlstr, Boolean remember, GlobalsType *g);
// Boolean remember: true if we are loading a WML page (and not an image), sowe set gLastURL to current URL, needed for relative links later on
int wapCreateUrlStr(char target[], char url[], GlobalsType *g);

#endif _wap_h_
